/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2008 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */


#import <UIKit/UIKit.h>
#import "AccountView.h"

@interface MainSingleView : UIViewController {
    
    enum StatusSingleIconId {
        MAIN_SINGLE_VIEW_STATUS_ICON_NULL    = -1,
        MAIN_SINGLE_VIEW_STATUS_ICON_SUCCESS = 0,
        MAIN_SINGLE_VIEW_STATUS_ICON_FAILURE = 1,
        MAIN_SINGLE_VIEW_STATUS_ICON_MAX
    };
    
    NSMutableArray	*menuList;

    UIWindow* window;
    UIBarButtonItem* settingsButton;
    UIButton* syncButton;
	UIButton* contactsButton;
	UIButton* stopButton;
	UIButton* infoButton;
    UITextView* textView;  
	AccountView* accountView;

	UIButton *syncOrSignInButton;
    UILabel* synchronizeText;
    UILabel* syncCancelText;
    UILabel* contactsText;
    UILabel* contactsStatusText;
    UILabel* textLabel;
    int syncArrow;
    UIImageView* logo;
    UIImageView* background;
    UIImageView* contactsLogo;
    UIImageView* buttonDarkBlue;
    UIImageView* buttonBlue;
    UIImageView* iconSyncAllBlue;
    UIImageView* iconSyncDark[15];
    NSTimer *timer;
    NSString* syncContactText;
    NSString* rightTitle;
    bool stopDisplayed;
    
    int idx;
    
    UIImageView* statusIcons[MAIN_SINGLE_VIEW_STATUS_ICON_MAX];
    
    UIFont * large_font;
    UIFont * small_font;
    UIFont * medium_font;
}

// Public
- (void)disableAllButtons;
- (void)enableAllButtons;
- (void)updateContactSyncStatus:(NSString*)msg iconIdx:(StatusSingleIconId) iconIdx;
- (void)updateContactSyncStatus:(NSString*)msg;
- (void)updateContactSyncStatusDuringSync:(NSString*)msg;
- (void)startContactSyncArrowAnimation;
- (void)cancelContactSyncArrowAnimation;
- (void)setSyncAllView;
- (void)setSyncContactsView;
- (void)resetSyncIcons;
- (void)showStopButton;
- (void)stopAction:(id)sender;
- (void)reload;

// Private
- (void)addComponents;
- (void)syncAllAction: (id)sender;
- (void)syncContactsAction: (id)sender;
- (void)syncAnimation:(NSTimer *)timer;
- (void)settingsAction:(id)sender;
- (NSString*) getLastSyncMessage;
- (void) showMessage: (NSString*) messageText titleText: (NSString*) titleText;
@end


