/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2008 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */


#import <UIKit/UIKit.h>

#include "customs.h"
#import "common.h"
#import "AboutView.h"
#import "base/Log.h"
#import "UIController.h"

@implementation AboutView

- (id)init {
	self = [super init];
	if (self)
	{
		// this title will appear in the navigation bar
		self.title =  [NSLocalizedString(@"AboutC",@"About ") stringByAppendingString:NSLocalizedString(@"AppName",@"Funambol")];
    }
	return self;
}

- (void) loadView{
    UIView *contentView = [[UIView alloc] initWithFrame:[[UIScreen mainScreen] applicationFrame]];
	self.view = contentView;
    
    [self.view setBackgroundColor:[UIColor whiteColor]];
    //[self addSubview:[UIColor whiteColor]];
	
    large_font = [UIFont boldSystemFontOfSize:22];
    small_font = [UIFont systemFontOfSize:14];
    //[small_font setFamilyName:@"Courier"];
    
    
    
    // The small Funambol logo in the Sync All rectangle
    logoImage = [[UIImageView alloc] initWithFrame: CGRectMake(100.0f, 20.0f, 128.0f, 128.0f)]; 
    [logoImage setImage:[UIImage imageNamed: @"logoImage.png"]];
    [self.view addSubview:logoImage];
    
    CGRect frame = CGRectMake(10.0, 150.0, 310.0, 250.0);
    
    aboutText = [[[UITextView alloc] initWithFrame:frame] autorelease];
    aboutText.textColor = [UIColor blackColor];
    aboutText.font = small_font ;
    //aboutText.delegate = self;
    aboutText.backgroundColor = [UIColor whiteColor];

    NSString* textValue;
        textValue = [[NSLocalizedString(@"aboutText1", @"about Text") 
                     stringByAppendingString:[[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleVersion"]]
                     stringByAppendingString:NSLocalizedString(@"aboutText2", @"about Text")];
    
    poweredbyImage = [[UIImageView alloc] initWithFrame: CGRectMake(72.0f, 200.0f, 172.0f, 32.0f)]; 
    [poweredbyImage setImage:[UIImage imageNamed:@"poweredby.png"]];
    
    if( POWEREDBY ){
        [aboutText addSubview:poweredbyImage];
    }

    aboutText.text = textValue;

    aboutText.textAlignment = UITextAlignmentCenter;
    
    aboutText.userInteractionEnabled = NO;
    
 
    [self.view addSubview:aboutText];
}

- (void) reload {
}

- (void)dealloc {

    [large_font release];
    [small_font release];
    [backButton release];
    
    [logoImage release];
    [poweredbyImage release];
    [aboutText release];
    [eegg release];
    [super dealloc];
}

@end