/*
 * Funambol is a mobile platform developed by Funambol, Inc.
 * Copyright (C) 2010 Canonical Group Ltd.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT  OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Canonical Group Ltd. headquarters at:
 *
 *   27th Floor Millbank Tower
 *   21-24 Millbank
 *   London SW1P 4QP
 *   United Kingdom
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */

#import "URLQueryStringParser.h"


@implementation URLQueryStringParser

- (id) initWithURL:(NSURL *)url {
	self = [super init];
	if (self != nil) {
		self.queryDict = [NSMutableDictionary dictionary];

		NSString *query = [url query];
		NSArray *queryPairs = [query componentsSeparatedByString:@"&"];
		for (NSString *pair in queryPairs) {
			// take chunk and break it on @"=", setting key and value in dict
			NSArray *keyValue = [pair componentsSeparatedByString:@"="];
			[self.queryDict setObject:[keyValue objectAtIndex:1] forKey:[keyValue objectAtIndex:0]];
		}
	}
	return self;
}

- (NSString *)queryStringValueForKey:(NSString *)key {
	return [self.queryDict objectForKey:key];
}

- (void) dealloc {
	self.queryDict = nil;
	[super dealloc];
}

@synthesize queryDict;

@end
