//
//  NSDictionary+Extras.m
//  iSub
//
//  Created by Aaron Brethorst on 9/20/10.
//  Copyright 2010 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "NSDictionary+Extras.h"

// helper function: get the string form of any object
static NSString *toString(id object)
{
	return [NSString stringWithFormat: @"%@", object];
}

// helper function: get the url encoded string form of any object
static NSString *urlEncode(id object)
{
	NSString *string = toString(object);
	return [string stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
}

@implementation NSDictionary (Extras)

- (NSString*)urlEncodedString
{
	NSMutableArray *parts = [NSMutableArray array];
	
	for (id key in self)
	{
		id value = [self objectForKey:key];
		NSString *part = [NSString stringWithFormat:@"%@=%@",urlEncode(key),urlEncode(value)];
		[parts addObject:part];
	}
	return [parts componentsJoinedByString:@"&"];
}

- (id)nilifiedValueForKey:(NSString*)aKey
{
	id value = [self objectForKey:aKey];
	
	if (value && ![[NSNull null] isEqual:value])
	{
		return value;
	}
	else 
	{
		return nil;
	}	
}

@end