//
//  NSNumber+Extras.m
//  iSub
//
//  Created by Aaron Brethorst on 9/25/10.
//  Copyright 2010 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "NSNumber+Extras.h"

@implementation NSNumber (Extras)

- (NSString*)minutesAndSeconds
{
	return [NSNumber minutesAndSecondsFor:[self intValue]];
}

- (NSString*)negativeMinutesAndSeconds
{
	return [NSString stringWithFormat:@"-%@", [self minutesAndSeconds]];
}

+ (NSString*)minutesAndSecondsFor:(int)val
{
	int seconds = val;
	int minutes = seconds / 60;
	seconds = seconds % 60;
	
	return [NSString stringWithFormat:@"%d:%@%d", minutes, (seconds >= 10 ? @"" : @"0"), seconds];
}

+ (NSString*)negativeMinutesAndSecondsFor:(int)val
{
	return [NSString stringWithFormat:@"-%@", [NSNumber minutesAndSecondsFor:val]]; 
}

@end
