//
//  NSString+Extras.m
//  iSub
//
//  Created by Zachery Bir on 5/23/11.
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "NSString+Extras.h"


@implementation NSString (NSString_Extras)

- (NSString *)dearticlizedString
{
    NSError *error = NULL;
    NSRegularExpression *expression = [NSRegularExpression regularExpressionWithPattern:@"^(the|a|an|le|les|la|el|las|los)\\s(.*)$"
                                                                                options:NSRegularExpressionCaseInsensitive
                                                                                  error:&error];
    
    NSString *dearticlized = [expression stringByReplacingMatchesInString:self
                                                                  options:NSMatchingWithoutAnchoringBounds
                                                                    range:NSMakeRange(0, [self length])
                                                             withTemplate:@"$2, $1"];
    
    return dearticlized;
}

- (NSString *)dearticlizedIndex
{
    NSString *index = [[self dearticlizedString] substringToIndex:1];
    
    return index;
}
@end
