//
//  AlbumArtistUITableViewCell.m
//  iSub
//
//  Created by Zachery Bir on 4/12/11.
//  Copyright 2011 Canonical. All rights reserved.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "AlbumArtistUITableViewCell.h"

@implementation AlbumArtistUITableViewCell
@synthesize coverArtView, albumNameLabel, artistNameLabel;

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
		self.coverArtView = [[[UIImageView alloc] init] autorelease];
		[self.contentView addSubview:self.coverArtView];
		
		self.albumNameLabel = [[[UILabel alloc] init] autorelease];
		self.albumNameLabel.highlightedTextColor = [UIColor whiteColor];
		self.albumNameLabel.font = [UIFont boldSystemFontOfSize:[UIFont labelFontSize]];
		[self.contentView addSubview:self.albumNameLabel];

		self.artistNameLabel = [[[UILabel alloc] init] autorelease];
		self.artistNameLabel.highlightedTextColor = [UIColor whiteColor];
        self.artistNameLabel.textColor = [UIColor grayColor];
		self.artistNameLabel.font = [UIFont systemFontOfSize:[UIFont systemFontSize]];
		[self.contentView addSubview:self.artistNameLabel];
    }
    return self;
}

- (void)layoutSubviews {
	self.albumNameLabel.frame = CGRectMake(70, 10, 235, 20);
    self.artistNameLabel.frame = CGRectMake(70, 30, 235, 20);
	self.coverArtView.frame = CGRectMake(0, 0, 60, 60);
	
    [super layoutSubviews];
}


- (void)dealloc {
	[albumNameLabel release];
    [artistNameLabel release];
	[coverArtView release];
    [super dealloc];
}


@end
