//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "CachedSongsPlaylist.h"

#import "Song.h"


@implementation CachedSongsPlaylist
@synthesize playlistId;

+ (CachedSongsPlaylist*)cachedSongsPlaylist
{
	CachedSongsPlaylist *playlist = [[[self alloc] init] autorelease];
	playlist.playlistId = nil;
	return playlist;
}

- (NSString*)name;
{
	return NSLocalizedString(@"Cached Songs", @"Name of the cached songs playlist");
}

- (NSSet*)songs;
{
	NSArray *songs = [PerThreadManagedObjectContext() fetchObjectsForEntityName:@"Song" withPredicate:@"cachedSongPath != NIL", nil];
	return [NSSet setWithArray:songs];
}

- (BOOL)isEditable;
{
	return NO;
}

- (NSError*)loadSongs;
{
	return nil;
}

@end
