//
//  Playlist.h
//  iSub
//
//  Created by Aaron Brethorst on 8/26/10.
//  Copyright 2010 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>

@class Song, PlaylistSongIndex;

@interface Playlist : NSManagedObject
{
}
@property(nonatomic,retain) NSString *name;
@property(nonatomic,retain) NSString *playlistId;
@property(nonatomic,retain) NSSet *playlistSongIndexes;
@property(nonatomic,readonly) NSArray *songs;

+ (BOOL)playlistWithNameExists:(NSString*)aPlaylistName;
+ (Playlist*)playlistWithName:(NSString*)aPlaylistName;
- (BOOL)matchesSearchQuery:(NSString *)query;
- (NSError*)loadSongs;
- (BOOL)isEditable;
- (void)addSong:(Song *)song;
- (void)removeSong:(Song *)song;
@end

// coalesce these into one @interface Album (CoreDataGeneratedAccessors) section
@interface Playlist (CoreDataGeneratedAccessors)
- (void)addPlaylistSongIndexesObject:(PlaylistSongIndex *)value;
- (void)removePlaylistSongIndexesObject:(PlaylistSongIndex *)value;
- (void)addPlaylistSongIndexes:(NSSet *)value;
- (void)removePlaylistSongIndexes:(NSSet *)value;
@end
