//
//  Song.h
//  iSub
//
//  Created by Ben Baron on 2/28/10.
//  Copyright 2010 Ben Baron. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without modification, 
//  are permitted provided that the following conditions are met:
//  
//  * Redistributions of source code must retain the above copyright notice, this 
//    list of conditions and the following disclaimer.
//  * Redistributions in binary form must reproduce the above copyright notice, 
//    this list of conditions and the following disclaimer in the documentation 
//    and/or other materials provided with the distribution.
//  * Neither the my name nor the names of my contributors may be used to endorse
//    or promote products derived from this software without specific prior written 
//    permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
//  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
//  SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
//  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
//  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
//  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
//  DAMAGE.

@class Artist, Album, PlaylistSongIndex;

@interface Song : NSManagedObject
{
}
@property (nonatomic, retain) NSString *title;
@property (nonatomic, retain) NSString *songId;
@property (nonatomic, retain) NSString *artist;
@property (nonatomic, retain) NSString *album;
@property (nonatomic, retain) NSString *genre;
@property (nonatomic, retain) NSString *coverArtId;
@property (nonatomic, retain) NSString *path;
@property (nonatomic, retain) NSNumber *duration;
@property (nonatomic, retain) NSNumber *bitRate;
@property (nonatomic, retain) NSNumber *track;
@property (nonatomic, retain) NSNumber *discNumber;
@property (nonatomic, retain) NSNumber *year;
@property (nonatomic, retain) NSNumber *size;
@property (nonatomic, retain) Artist *artistEntity;
@property (nonatomic, retain) Album *albumEntity;
@property (nonatomic, retain) NSSet *playlistSongIndexes;
@property (nonatomic, retain) NSString *cachedSongPath;

+ (BOOL)songWithIdExists:(NSString*)aSongId;
+ (Song*)songWithId:(NSString*)aSongId;
- (BOOL)matchesSearchQuery:(NSString *)query;
- (NSString *)dearticlizedTitle;
- (BOOL)cachedSongExists;
- (NSURL*)cachedSongURL;
@end

@interface Song (CoreDataGeneratedAccessors)
- (void)addPlaylistSongIndexesObject:(PlaylistSongIndex *)value;
- (void)removePlaylistSongIndexesObject:(PlaylistSongIndex *)value;
- (void)addPlaylistSongIndexes:(NSSet *)value;
- (void)removePlaylistSongIndexes:(NSSet *)value;
@end
