//
//  AlbumListParser.m
//  iSub
//
//  Created by Zachery Bir on 4/7/11.
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "AlbumListParser.h"
#import "Album.h"

@implementation AlbumListParser

- (void) subsonicErrorCode:(NSString *)errorCode message:(NSString *)message
{
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:message delegate:nil cancelButtonTitle:NSLocalizedString(@"Dismiss", @"") otherButtonTitles:nil];
	[alert show];
	[alert release];
}


- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict 
{
	if ([elementName isEqualToString:@"error"])
	{
		[self subsonicErrorCode:[attributeDict objectForKey:@"code"] message:[attributeDict objectForKey:@"message"]];
	}
	else if ([elementName isEqualToString:@"album"]) 
	{
		NSString *albumId = [attributeDict objectForKey:@"id"];
		NSString *albumTitle = [attributeDict objectForKey:@"title"];
		NSString *albumArtist = [attributeDict objectForKey:@"artist"];
		if ([albumTitle isEqual:@".AppleDouble"])
			return;
		
		Album *album = [Album albumWithId:albumId];
		if (!album)
		{
			album = [NSEntityDescription insertNewObjectForEntityForName:@"Album" inManagedObjectContext:PerThreadManagedObjectContext()];
			album.albumId = albumId;
		}
		album.title = albumTitle;
		album.artist = albumArtist;
		album.coverArtId = [attributeDict objectForKey:@"coverArt"];
		
		SaveContext();
	}
}

@end