//
//  Globals.m
//  iSub
//
//  Created by Aaron Brethorst on 5/13/11.
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "Globals.h"

NSURL* ApplicationDocumentsDirectory( void ) 
{
	return [[[NSFileManager defaultManager] URLsForDirectory:NSDocumentDirectory inDomains:NSUserDomainMask] lastObject];
}

NSURL* DatabaseFile( void )
{
    NSURL* docs = ApplicationDocumentsDirectory();
    return [docs URLByAppendingPathComponent:@"music.sqlite"];
}

BOOL CacheContainsFile(NSString *aFilePath)
{
	return [[NSFileManager defaultManager] fileExistsAtPath:aFilePath];
}

NSURL* CachedMusicDirectory( void )
{
	NSURL* docs = ApplicationDocumentsDirectory();
	return [docs URLByAppendingPathComponent:@"cached_music"];
}

NSString* CachedMusicPathForFilename(NSString *aFileName)
{
    return [[CachedMusicDirectory() path] stringByAppendingPathComponent:aFileName];
}

NSURL* CachedAlbumArtDirectory( void )
{
	NSURL* docs = ApplicationDocumentsDirectory();
	return [docs URLByAppendingPathComponent:@"cached_album_art"];    
}

NSString* CachedAlbumArtPathForArtId(NSString *anArtId)
{
    return [[CachedAlbumArtDirectory() path] stringByAppendingPathComponent:anArtId];
}

NSString * const NOTIF_downloadComplete = @"DownloadComplete";
NSString * const NOTIF_removeCachedContent = @"RemoveCachedContent";
NSString * const NOTIF_reloadAccountCredentials = @"ReloadAccountCredentials";
