//
//  Subsonic.h
//  iSub
//
//  Created by Aaron Brethorst on 9/23/10.
//  Copyright 2010 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <Foundation/Foundation.h>

@class Reachability;


@interface Subsonic : NSObject
{
    NSString *credsURL;
	NSString *defaultURL;
	NSString *defaultUserName;
	NSString *defaultPassword;
	NSString *cachedIP;
	NSInteger cachedIPHour;
}
@property BOOL hasCredentials;
@property(nonatomic,retain) NSString *credsURL;
@property(nonatomic,retain) NSString *defaultURL;
@property(nonatomic,retain) NSString *defaultUserName;
@property(nonatomic,retain) NSString *defaultPassword;
@property(nonatomic,retain) NSString *cachedIP;
@property(nonatomic,assign) NSInteger cachedIPHour;
@property (readonly, retain) Reachability *reachability;
+ (Subsonic *)sharedSubsonic;
- (NSURL *)getCredsURL;
- (NSURL *)getBaseURL:(NSString *)action;
- (NSURL *)getBaseURL:(NSString *)action parameters:(NSArray*)extraParameters;
- (NSURL *)getStreamingURLForSongId:(NSString*)songId;
- (void)removeCredentials;
- (void)storeUsername:(NSString*)username password:(NSString*)password;
@end
