//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "UONetworkStatusCoordinator.h"


@implementation UONetworkStatusCoordinator

static NSInteger activityCount;

+ (void)addNetworkActivity;
{
	dispatch_async(dispatch_get_main_queue(), ^(void) {
		if (++activityCount > 0)
			[[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:YES];
	});
}

+ (void)removeNetworkActivity;
{
	dispatch_async(dispatch_get_main_queue(), ^(void) {
		--activityCount;
		activityCount = MAX(0, activityCount);
		if (activityCount == 0)
			[[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
	});
}

@end
