//
//  URLQueryStringParser.m
//  iSub
//
//  Created by Zachery Bir.
//  Copyright 2010 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "URLQueryStringParser.h"

@implementation URLQueryStringParser

- (id) initWithURL:(NSURL *)url {
	self = [super init];
	if (self != nil) {
		self.queryDict = [NSMutableDictionary dictionary];
		
		NSString *query = [url query];
		NSArray *queryPairs = [query componentsSeparatedByString:@"&"];
		for (NSString *pair in queryPairs) {
			// take chunk and break it on @"=", setting key and value in dict
			NSArray *keyValue = [pair componentsSeparatedByString:@"="];
			[self.queryDict setObject:[keyValue objectAtIndex:1] forKey:[keyValue objectAtIndex:0]];
		}
	}
	return self;
}

- (NSString *)queryStringValueForKey:(NSString *)key {
	return [self.queryDict objectForKey:key];
}

- (void) dealloc {
	self.queryDict = nil;
	[super dealloc];
}

@synthesize queryDict;

@end
