//
//  AlbumArtLoader.h
//  iSub
//
//  Created by Aaron Brethorst on 5/4/11.
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <UIKit/UIKit.h>
#import "AlbumArtLoadingOperation.h"

@protocol AlbumArtLoaderDelegate<NSObject>
- (void)reloadImages;
@optional
- (void)performSelectorOnMainThread:(SEL)aSelector withObject:(id)arg waitUntilDone:(BOOL)wait;
@end


@interface AlbumArtLoader : NSObject <AlbumArtLoadingOperationDelegate>
{
	NSMutableSet *downloadedURLs;
	NSMutableDictionary *downloadCache;
	NSOperationQueue *queue;
	id<AlbumArtLoaderDelegate> delegate;
	int imageSize;
    UIImage *defaultAlbumArt;
}
@property(nonatomic) int imageSize;
@property(nonatomic,assign) id<AlbumArtLoaderDelegate> delegate;
@property(nonatomic,retain) UIImage *defaultAlbumArt;
- (UIImage*)imageForArtID:(NSString*)artID error:(NSError**)error;
- (void)download:(NSString*)artID;
+ (NSString*)cacheSize;
@end
