//
//  AlbumArtLoadingOperation.h
//  iSub
//
//  Created by Aaron Brethorst on 5/4/11.
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <UIKit/UIKit.h>
#import "AbstractNetworkOperation.h"

@protocol AlbumArtLoadingOperationDelegate<NSObject>
- (void)imageLoaded:(UIImage*)image forArtId:(NSString *)artId;
@end

@interface AlbumArtLoadingOperation : AbstractNetworkOperation
{	
	NSMutableData * _data;
    NSString *_artId;
	id<AlbumArtLoadingOperationDelegate> delegate;
}
@property (nonatomic, assign) id<AlbumArtLoadingOperationDelegate> delegate;
@property (readonly, retain) NSData * data;
- (id)initWithArtId:(NSString *)artId URL:(NSURL *)url;

+ (id)AlbumArtLoaderWithUrlString:(NSString *)urlString;

@end