//
//  DownloadOperation.h
//  iSub
//
//  Created by Aaron Brethorst on 5/12/11.
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <UIKit/UIKit.h>
#import "AbstractNetworkOperation.h"

@protocol DownloadOperationDelegate
- (void)songDownloadedToPath:(NSString*)path;
@optional
- (void)performSelectorOnMainThread:(SEL)aSelector withObject:(id)arg waitUntilDone:(BOOL)wait;
@end


@interface DownloadOperation : AbstractNetworkOperation
{
	NSString *_filePath;
	NSFileHandle *_fileHandle;
	
	id<DownloadOperationDelegate> _delegate;
}
@property(nonatomic,retain) NSString *filePath;
@property(nonatomic,assign) id<DownloadOperationDelegate> delegate;

+ (id)downloadOperationWithURL:(NSURL*)anURL filePath:(NSString*)aFilePath;
- (id)initWithUrl:(NSURL*)anUrl filePath:(NSString*)aFilePath;

@end