//
//  SongViewController.h
//  iSub
//
//  Created by Ben Baron on 2/27/10.
//  Copyright 2010 Ben Baron. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without modification, 
//  are permitted provided that the following conditions are met:
//  
//  * Redistributions of source code must retain the above copyright notice, this 
//    list of conditions and the following disclaimer.
//  * Redistributions in binary form must reproduce the above copyright notice, 
//    this list of conditions and the following disclaimer in the documentation 
//    and/or other materials provided with the distribution.
//  * Neither the my name nor the names of my contributors may be used to endorse
//    or promote products derived from this software without specific prior written 
//    permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
//  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
//  SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
//  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
//  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
//  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
//  DAMAGE.

#import <UIKit/UIKit.h>
#import "Subsonic.h"
#import "SubsonicViewController.h"
#import "AlbumArtLoader.h"

@class AudioStreamer, Song;

@interface SongViewController : SubsonicViewController <AlbumArtLoaderDelegate>
{
    AlbumArtLoader *loader;
	UIToolbar *musicToolbar;
	UIView *volumeSlider;
	UIView *headerView;
	UIImageView *coverArtImageView;
	UIButton *songInfoToggleButton;
	UIButton *backButton;
	
	UILabel *artistLabel;
	UILabel *songLabel;
	UILabel *albumLabel;
	
	UIView *songInfoBox;
	
	UISlider *scrubberSlider;
	UILabel *elapsedLabel;
	UILabel *remainingLabel;
	UILabel *trackMOfNLabel;
	
	UIButton *repeatButton;
	UIButton *shuffleButton;
	
	NSTimer *heartbeat;
}
@property(nonatomic,retain) IBOutlet UIButton *repeatButton;
@property(nonatomic,retain) IBOutlet UIButton *shuffleButton;
@property(nonatomic,retain) IBOutlet UILabel *trackMOfNLabel;
@property(nonatomic,retain) IBOutlet UILabel *elapsedLabel;
@property(nonatomic,retain) IBOutlet UILabel *remainingLabel;
@property(nonatomic,retain) IBOutlet UISlider *scrubberSlider;
@property(nonatomic,retain) IBOutlet UILabel *artistLabel;
@property(nonatomic,retain) IBOutlet UILabel *songLabel;
@property(nonatomic,retain) IBOutlet UILabel *albumLabel;
@property(nonatomic,retain) IBOutlet UIView *headerView;
@property(nonatomic,retain) IBOutlet UIToolbar *musicToolbar;
@property(nonatomic,retain) IBOutlet UIView *volumeSlider;
@property(nonatomic,retain) IBOutlet UIImageView *coverArtImageView;
@property(nonatomic,retain) IBOutlet UIButton *songInfoToggleButton;
@property(nonatomic,retain) IBOutlet UIButton *backButton;
@property(nonatomic,retain) IBOutlet UIView *songInfoBox;

- (IBAction)shuffle:(id)sender;
- (IBAction)repeat:(id)sender;
- (IBAction)popFromStack:(id)sender;
- (IBAction)songInfoToggle:(id)sender;
- (IBAction)playButtonPressed:(id)sender;
- (IBAction)prevButtonPressed:(id)sender;
- (IBAction)nextButtonPressed:(id)sender;

- (IBAction)touchedSlider;
- (IBAction)movingSlider;
- (IBAction)movedSlider;
@end

