//
//  SubsonicTableViewController.h
//  iSub
//
//  Created by Aaron Brethorst on 8/25/10.
//  Copyright 2010 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import <UIKit/UIKit.h>
#import "PullRefreshTableViewController.h"
#import "Subsonic.h"
#import "Song.h"

@class Album;

@interface SubsonicTableViewController : PullRefreshTableViewController <UIAlertViewDelegate, UISearchDisplayDelegate, UISearchBarDelegate>
{
	BOOL showProgressHUD;
	NSTimer *respondToRemoteTimer;
    NSMutableArray *tableData;
	NSMutableArray *searchResults;
	id <NSXMLParserDelegate> parserDelegate;
	NSString *viewName;
	
@protected
	BOOL canStream;
	BOOL canCache;
}
- (id)initWithTitle:(NSString *)title;
- (void)showLoadingUI;
- (void)showLoadingUIWithText:(NSString*)text;
- (void)hideLoadingUI;
- (void)showMessage:(NSString*)message withTitle:(NSString*)title;
- (void)showError:(NSString*)errorMessage;

- (void)didSelectSong:(Song*)song withPlaylist:(NSArray*)playlist;

//Data Loader
- (IBAction)reload:(id)sender;
- (void)loadData:(BOOL)force;
- (void)loadLocalData;
- (void)beginLoadingRemoteData:(NSString*)force;
- (void)finishLoadingData;
- (void)failedLoadingData:(NSError*)error;
- (void)reachabilityChanged:(NSNotification*)notification;
- (void)updateReachability:(Reachability*)reachability;

- (void)reloadCredentials:(id)sender;
- (void)resetCredentials:(id)sender;
- (void)resetTableData:(id)sender;

- (IBAction)nowPlayingAction:(id)sender;

@property(nonatomic,retain) NSMutableArray *tableData;
@property(nonatomic,retain) NSMutableArray *searchResults;
@property(nonatomic,assign) id<NSXMLParserDelegate> parserDelegate;
@property(nonatomic,retain) NSString *viewName;

extern NSString * const NOTIF_reloadAccountCredentials;
extern NSString * const NOTIF_removeCachedContent;
@end
